/*
 * $Id: lbc_packet_size_range.h,v 1.2 2001/06/28 21:05:26 laik Exp $
 *
 * This file contains information necessary to use the link bandwidth
 * calculation routines in sigma mode.
 *
 * Copyright (C) 1998 Kevin Lai
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __LBC_PACKET_SIZE_RANGE_H__
#define __LBC_PACKET_SIZE_RANGE_H__

#include "kl_array.h"
#include "dpcap_flow.h"

struct lbc_packet_size_range_t;
typedef struct lbc_packet_size_range_t lbc_packet_size_range_t;

void
lbc_packet_size_range_resize(
    lbc_packet_size_range_t *ps_range, unsigned int min_packet_size,
    unsigned int max_packet_size);

lbc_packet_size_range_t *
lbc_packet_size_range_new(
    unsigned int num_packet_sizes, unsigned int receive_per_size,
    unsigned int min_packet_size, unsigned int max_packet_size);

void
lbc_packet_size_range_free(lbc_packet_size_range_t *ps_range);

void
lbc_packet_size_range_add_sample(
    lbc_packet_size_range_t *ps_range, const DPCapFlowPacket *packet,
    const struct timespec *delay);

int
lbc_packet_size_range_regression(
    lbc_packet_size_range_t *ps_range, double *slope, double *intercept,
    double *confidence);

void
lbc_packet_size_range_find_min_count(
    lbc_packet_size_range_t *ps_range, unsigned int *packet_count,
    unsigned int *packet_size);

void
lbc_packet_size_range_find_off_line(
    lbc_packet_size_range_t *ps_range, double slope, double intercept, 
    int *off_line_size);

void
lbc_packet_size_range_get_string(
    lbc_packet_size_range_t *ps_range, KLArray *array);

#endif


