/*
 * $Id: lbc_sigma.h,v 1.3 2001/07/19 21:52:20 laik Exp $
 *
 * This file contains information necessary to use the link bandwidth
 * calculation routines in sigma mode.
 *
 * Copyright (C) 1998 Kevin Lai
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __LBC_SIGMA_H__
#define __LBC_SIGMA_H__

#include "kl_exception.h"

#include "dpcap_flow.h"

#include "transport.h"

typedef struct LBCSigmaStatistics {
    double slope;
    double intercept;
    double confidence;
} LBCSigmaStatistics;

struct LBCSigma;
typedef struct LBCSigma LBCSigma;

typedef struct LBCSigmaDef {
    TransportFlow flow;
    unsigned int num_packet_sizes;
    unsigned int receive_per_size;
} LBCSigmaDef;

LBCSigma *
lbc_sigma_new(LBCSigmaDef *def);

void
lbc_sigma_free(LBCSigma *lbc_sigma);

void
lbc_sigma_get_statistics(
    LBCSigma *lbc_sigma, LBCSigmaStatistics *lbc_sigma_statistics, 
    KLArray *array);

int
lbc_sigma_send_packet(LBCSigma *lbc_sigma);

int
lbc_sigma_sample_received(
    LBCSigma *lbc_sigma, const DPCapFlowPacket *packet, 
    const struct timespec *delay, unsigned int timing_type);

#endif


